#include <3ds.h>
#include <citro3d.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "lodepng.h"
#include "vshader_shbin.h"
#include "jistan_png.h"
// 1.XN[ݒȂǂ̒`
#define CLEAR_COLOR 0x000000FF // wiœhԂ(RRGGBBFF)
#define DISPLAY_TRANSFER_FLAGS \
	(GX_TRANSFER_FLIP_VERT(0) | GX_TRANSFER_OUT_TILED(0) | GX_TRANSFER_RAW_COPY(0) | \
	GX_TRANSFER_IN_FORMAT(GX_TRANSFER_FMT_RGBA8) | GX_TRANSFER_OUT_FORMAT(GX_TRANSFER_FMT_RGB8) | \
	GX_TRANSFER_SCALING(GX_TRANSFER_SCALE_NO))
#define TEXTURE_TRANSFER_FLAGS \
	(GX_TRANSFER_FLIP_VERT(1) | GX_TRANSFER_OUT_TILED(1) | GX_TRANSFER_RAW_COPY(0) | \
	GX_TRANSFER_IN_FORMAT(GX_TRANSFER_FMT_RGBA8) | GX_TRANSFER_OUT_FORMAT(GX_TRANSFER_FMT_RGBA8) | \
	GX_TRANSFER_SCALING(GX_TRANSFER_SCALE_NO))
#define NUM_SPRITES 256 // p\ȍőXvCg-1
typedef struct {
	int x,y;
	int dx, dy;
	int image;
}Sprite;
Sprite sprites[NUM_SPRITES];
struct { float left, right, top, bottom; } images[1] = {
	{0.0f, 1.0f, 0.0f, 1.0f},
};

// 2.XvCg`(Op`x2̓\荇킹ŃXvCg1)
void drawSprite( int x, int y, int width, int height, int image ) {
	float left = images[image].left;
	float right = images[image].right;
	float top = images[image].top;
	float bottom = images[image].bottom;
	C3D_ImmDrawBegin(GPU_TRIANGLES);
		// Op`E̕`
		C3D_ImmSendAttrib(x, y, 0.5f, 0.0f); // v0=position
		C3D_ImmSendAttrib( left, top, 0.0f, 0.0f);
		C3D_ImmSendAttrib(x+width, y+height, 0.5f, 0.0f);
		C3D_ImmSendAttrib( right, bottom, 0.0f, 0.0f);
		C3D_ImmSendAttrib(x+width, y, 0.5f, 0.0f);
		C3D_ImmSendAttrib( right, top, 0.0f, 0.0f);
		// Op`̕`
		C3D_ImmSendAttrib(x, y, 0.5f, 0.0f); // v0=position
		C3D_ImmSendAttrib( left, top, 0.0f, 0.0f);
		C3D_ImmSendAttrib(x, y+height, 0.5f, 0.0f);
		C3D_ImmSendAttrib( left, bottom, 0.0f, 0.0f);
		C3D_ImmSendAttrib(x+width, y+height, 0.5f, 0.0f);
		C3D_ImmSendAttrib( right, bottom, 0.0f, 0.0f);
	C3D_ImmDrawEnd();
}

// 3.3DݒEPNG[h
static DVLB_s* vshader_dvlb;
static shaderProgram_s program;
static int uLoc_projection;
static C3D_Mtx projection;
static C3D_Tex spritesheet_tex;
static void sceneInit(void) {
	vshader_dvlb = DVLB_ParseFile((u32*)vshader_shbin, vshader_shbin_size);
	shaderProgramInit(&program);
	shaderProgramSetVsh(&program, &vshader_dvlb->DVLE[0]);
	C3D_BindProgram(&program);
	uLoc_projection = shaderInstanceGetUniformLocation(program.vertexShader, "projection");
	C3D_AttrInfo* attrInfo = C3D_GetAttrInfo();
	AttrInfo_Init(attrInfo);
	AttrInfo_AddLoader(attrInfo, 0, GPU_FLOAT, 3); // v0=position
	AttrInfo_AddLoader(attrInfo, 1, GPU_FLOAT, 2); // v2=texcoord
	Mtx_OrthoTilt(&projection, 0.0, 400.0, 240.0, 0.0, 0.0, 1.0);
	C3D_BufInfo* bufInfo = C3D_GetBufInfo();
	BufInfo_Init(bufInfo);
	unsigned char* image;
	unsigned width, height;
	lodepng_decode32(&image, &width, &height, jistan_png, jistan_png_size);
	u8 *gpusrc = linearAlloc(width*height*4);
	u8* src=image; u8 *dst=gpusrc;
	for(int i = 0; i<width*height; i++) {
		int r = *src++; int g = *src++; int b = *src++; int a = *src++;
		*dst++ = a; *dst++ = b; *dst++ = g; *dst++ = r;
	}
	GSPGPU_FlushDataCache(gpusrc, width*height*4);
	C3D_TexInit(&spritesheet_tex, width, height, GPU_RGBA8);
	GX_DisplayTransfer ((u32*)gpusrc, GX_BUFFER_DIM(width,height), (u32*)spritesheet_tex.data, GX_BUFFER_DIM(width,height), TEXTURE_TRANSFER_FLAGS);
	gspWaitForPPF();
	C3D_TexSetFilter(&spritesheet_tex, GPU_LINEAR, GPU_NEAREST);
	C3D_TexBind(0, &spritesheet_tex);
	free(image);
	linearFree(gpusrc);
	C3D_TexEnv* env = C3D_GetTexEnv(0);
	C3D_TexEnvSrc(env, C3D_Both, GPU_TEXTURE0, 0, 0);
	C3D_TexEnvOp(env, C3D_Both, 0, 0, 0);
	C3D_TexEnvFunc(env, C3D_Both, GPU_REPLACE);
	C3D_DepthTest(true, GPU_GEQUAL, GPU_WRITE_ALL);
}

// 4.C[`
int main(int argc, char **argv) {
	gfxInitDefault();
	C3D_Init(C3D_DEFAULT_CMDBUF_SIZE);
	C3D_RenderTarget* target = C3D_RenderTargetCreate(240, 400, GPU_RB_RGBA8, GPU_RB_DEPTH24_STENCIL8);
	C3D_RenderTargetSetClear(target, C3D_CLEAR_ALL, CLEAR_COLOR, 0);
	C3D_RenderTargetSetOutput(target, GFX_TOP, GFX_LEFT, DISPLAY_TRANSFER_FLAGS);
	// Initialize the scene
	sceneInit();
	// 摜`W`
	sprites[0].x = 64;
	sprites[0].y = 64;

	// C[v
	while (aptMainLoop()) {
		// 5.`揈
		C3D_FrameBegin(C3D_FRAME_SYNCDRAW);
			C3D_FrameDrawOn(target);
			// XvCgXV
			C3D_FVUnifMtx4x4(GPU_VERTEX_SHADER, uLoc_projection, &projection);
			drawSprite( sprites[0].x, sprites[0].y,128,128, sprites[0].image);
			// ܂
		C3D_FrameEnd(0);
	}
	// HOME{^̏
	shaderProgramFree(&program);
	DVLB_Free(vshader_dvlb);
	C3D_Fini();
	gfxExit();
	return 0;
}
